cryptonite-0.30: Cryptography Primitives sink

Safe Haskell | Safe-Inferred
Language | Haskell2010

Crypto.PubKey.ECC.ECDSA

Description

WARNING: Signature operations may leak the private key. Signature verification should be safe.

Synopsis

- data Signature = Signature {
  - sign_r :: Integer
  - sign_s :: Integer
  }
- type PublicPoint = Point
- data PublicKey = PublicKey {
  - public_curve :: Curve
  - public_q :: PublicPoint
  }
- type PrivateNumber = Integer
- data PrivateKey = PrivateKey {
  - private_curve :: Curve
  - private_d :: PrivateNumber
  }
- data KeyPair = KeyPair Curve PublicPoint PrivateNumber
- toPublicKey :: KeyPair -> PublicKey
- toPrivateKey :: KeyPair -> PrivateKey
- signWith :: (ByteArrayAccess msg, HashAlgorithm hash) => Integer -> PrivateKey -> hash -> msg -> Maybe Signature
- signDigestWith :: HashAlgorithm hash => Integer -> PrivateKey -> Digest hash -> Maybe Signature
- sign :: (ByteArrayAccess msg, HashAlgorithm hash, MonadRandom m) => PrivateKey -> hash -> msg -> m Signature
- signDigest :: (HashAlgorithm hash, MonadRandom m) => PrivateKey -> Digest hash -> m Signature
- verify :: (ByteArrayAccess msg, HashAlgorithm hash) => hash -> PublicKey -> Signature -> msg -> Bool
- verifyDigest :: HashAlgorithm hash => PublicKey -> Signature -> Digest hash -> Bool

# Documentation

data Signature Source #

Represent a ECDSA signature namely R and S.

Constructors

Signature |

Fields

- sign_r :: Integer

  ECDSA r

- sign_s :: Integer

  ECDSA s

#### Instances

Instances details

Data Signature Source # |

Instance details

Defined in Crypto.PubKey.ECC.ECDSA

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Signature -> c Signature Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Signature Source #

toConstr :: Signature -> Constr Source #

dataTypeOf :: Signature -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Signature) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Signature) Source #

gmapT :: (forall b. Data b => b -> b) -> Signature -> Signature Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Signature -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Signature -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Signature -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Signature -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Signature -> m Signature Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Signature -> m Signature Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Signature -> m Signature Source #

Read Signature Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods readsPrec :: Int -> ReadS Signature Source # readList :: ReadS [Signature] Source # readPrec :: ReadPrec Signature Source # readListPrec :: ReadPrec [Signature] Source #
Show Signature Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods showsPrec :: Int -> Signature -> ShowS Source # show :: Signature -> String Source # showList :: [Signature] -> ShowS Source #
Eq Signature Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods (==) :: Signature -> Signature -> Bool Source # (/=) :: Signature -> Signature -> Bool Source #

type PublicPoint = Point Source #

ECC Public Point

data PublicKey Source #

ECDSA Public Key.

Constructors

PublicKey |

Fields

- public_curve :: Curve
- public_q :: PublicPoint

#### Instances

Instances details

Data PublicKey Source # |

Instance details

Defined in Crypto.PubKey.ECC.ECDSA

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PublicKey -> c PublicKey Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PublicKey Source #

toConstr :: PublicKey -> Constr Source #

dataTypeOf :: PublicKey -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PublicKey) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PublicKey) Source #

gmapT :: (forall b. Data b => b -> b) -> PublicKey -> PublicKey Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> PublicKey -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PublicKey -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

Read PublicKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods readsPrec :: Int -> ReadS PublicKey Source # readList :: ReadS [PublicKey] Source # readPrec :: ReadPrec PublicKey Source # readListPrec :: ReadPrec [PublicKey] Source #
Show PublicKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods showsPrec :: Int -> PublicKey -> ShowS Source # show :: PublicKey -> String Source # showList :: [PublicKey] -> ShowS Source #
Eq PublicKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods (==) :: PublicKey -> PublicKey -> Bool Source # (/=) :: PublicKey -> PublicKey -> Bool Source #

type PrivateNumber = Integer Source #

ECC Private Number

data PrivateKey Source #

ECDSA Private Key.

Constructors

PrivateKey |

Fields

- private_curve :: Curve
- private_d :: PrivateNumber

#### Instances

Instances details

Data PrivateKey Source # |

Instance details

Defined in Crypto.PubKey.ECC.ECDSA

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PrivateKey -> c PrivateKey Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PrivateKey Source #

toConstr :: PrivateKey -> Constr Source #

dataTypeOf :: PrivateKey -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PrivateKey) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PrivateKey) Source #

gmapT :: (forall b. Data b => b -> b) -> PrivateKey -> PrivateKey Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> PrivateKey -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PrivateKey -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

Read PrivateKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods readsPrec :: Int -> ReadS PrivateKey Source # readList :: ReadS [PrivateKey] Source # readPrec :: ReadPrec PrivateKey Source # readListPrec :: ReadPrec [PrivateKey] Source #
Show PrivateKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods showsPrec :: Int -> PrivateKey -> ShowS Source # show :: PrivateKey -> String Source # showList :: [PrivateKey] -> ShowS Source #
Eq PrivateKey Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods (==) :: PrivateKey -> PrivateKey -> Bool Source # (/=) :: PrivateKey -> PrivateKey -> Bool Source #

data KeyPair Source #

ECDSA Key Pair.

Constructors

KeyPair Curve PublicPoint PrivateNumber |

#### Instances

Instances details

Data KeyPair Source # |

Instance details

Defined in Crypto.PubKey.ECC.ECDSA

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> KeyPair -> c KeyPair Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c KeyPair Source #

toConstr :: KeyPair -> Constr Source #

dataTypeOf :: KeyPair -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c KeyPair) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c KeyPair) Source #

gmapT :: (forall b. Data b => b -> b) -> KeyPair -> KeyPair Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> KeyPair -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> KeyPair -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> KeyPair -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> KeyPair -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> KeyPair -> m KeyPair Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> KeyPair -> m KeyPair Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> KeyPair -> m KeyPair Source #

Read KeyPair Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods readsPrec :: Int -> ReadS KeyPair Source # readList :: ReadS [KeyPair] Source # readPrec :: ReadPrec KeyPair Source # readListPrec :: ReadPrec [KeyPair] Source #
Show KeyPair Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods showsPrec :: Int -> KeyPair -> ShowS Source # show :: KeyPair -> String Source # showList :: [KeyPair] -> ShowS Source #
Eq KeyPair Source # |
Instance details Defined in Crypto.PubKey.ECC.ECDSA Methods (==) :: KeyPair -> KeyPair -> Bool Source # (/=) :: KeyPair -> KeyPair -> Bool Source #

toPublicKey :: KeyPair -> PublicKey Source #

Public key of a ECDSA Key pair.

toPrivateKey :: KeyPair -> PrivateKey Source #

Private key of a ECDSA Key pair.

signWith Source #

Arguments

:: (ByteArrayAccess msg, HashAlgorithm hash) |
=> Integer | k random number
-> PrivateKey | private key
-> hash | hash function
-> msg | message to sign
-> Maybe Signature |

Sign message using the private key and an explicit k number.

WARNING: Vulnerable to timing attacks.

signDigestWith Source #

Arguments

:: HashAlgorithm hash |
=> Integer | k random number
-> PrivateKey | private key
-> Digest hash | digest to sign
-> Maybe Signature |

Sign digest using the private key and an explicit k number.

WARNING: Vulnerable to timing attacks.

sign :: (ByteArrayAccess msg, HashAlgorithm hash, MonadRandom m) => PrivateKey -> hash -> msg -> m Signature Source #

Sign message using the private key.

WARNING: Vulnerable to timing attacks.

signDigest :: (HashAlgorithm hash, MonadRandom m) => PrivateKey -> Digest hash -> m Signature Source #

Sign digest using the private key.

WARNING: Vulnerable to timing attacks.

verify :: (ByteArrayAccess msg, HashAlgorithm hash) => hash -> PublicKey -> Signature -> msg -> Bool Source #

Verify a bytestring using the public key.

verifyDigest :: HashAlgorithm hash => PublicKey -> Signature -> Digest hash -> Bool Source #

Verify a digest using the public key.